/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.personenpruefung.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="PERSONEN_KONFLIKT.KonfliktArtAndKonfliktStatus",
     query="SELECT obj FROM PersonenKonflikt obj WHERE obj.personenKonfliktArt IN (?1) AND obj.personenKonfliktStatus IN (?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PERSONEN_KONFLIKT.PersonAndKonfliktArt",
     query="SELECT k FROM PersonenKonflikt k WHERE k.personendaten = ?1 AND k.personenKonfliktArt IN (?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PERSONEN_KONFLIKT.PersonAndKonfliktStatus",
     query="SELECT k FROM PersonenKonflikt k WHERE k.personendaten = ?1 AND k.personenKonfliktStatus IN (?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PERSONEN_KONFLIKT.WahlAndKonfliktArtAndKonfliktStatus",
     query="SELECT obj FROM PersonenKonflikt obj WHERE obj.personendaten.wahl = ?1 AND obj.personenKonfliktArt IN (?2) AND obj.personenKonfliktStatus IN (?3)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PERSONEN_KONFLIKT.WahlterminAndKonfliktArtAndKontoverbindungIban",
     query="SELECT w FROM PersonenKonflikt w JOIN FETCH w.personendaten p JOIN FETCH p.kontoverbindung kv WHERE w.personenKonfliktArt =?2 AND p.wahltermin = ?1 AND kv.iban = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PERSONEN_KONFLIKT.WahlterminAndKonfliktArt",
     query="SELECT w FROM PersonenKonflikt w WHERE w.personendaten.wahltermin = ?1 AND w.personenKonfliktArt =?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "PERSONEN_KONFLIKT")
// @javax.persistence.IdClass(PersonenKonfliktPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class PersonenKonflikt
extends AbstractPersonenKonflikt
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public PersonenKonflikt() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public PersonenKonflikt(PersonenKonflikt original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "personen_konflikt_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "PersonenKonflikt")
    @javax.persistence.TableGenerator(name = "PersonenKonflikt", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "PersonenKonflikt", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient PersonenKonfliktPK pkCache;

  @Override
  public PersonenKonfliktPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new PersonenKonfliktPK(getId());
    }

    return pkCache;
  }

  public static <E extends PersonenKonflikt> java.util.Map<PersonenKonfliktPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<PersonenKonfliktPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends PersonenKonflikt> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedPersonenKonfliktArt = false;
          hasChangedPersonenKonfliktStatus = false;
  
      hasChangedPersonendaten = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PERSONEN_KONFLIKT_ART", nullable = PersonenKonfliktConstants.PERSONEN_KONFLIKT_ART_NULLABLE)
    
  protected de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt personenKonfliktArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPersonenKonfliktArt = false;

  public boolean hasChangedPersonenKonfliktArt(){
    return hasChangedPersonenKonfliktArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPersonenKonfliktArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt wertNachLadenPersonenKonfliktArt;
  
  /**
   * 
   *
   * getter for PERSONEN_KONFLIKT.PERSONEN_KONFLIKT_ART
   */
    @Override   public  de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt getPersonenKonfliktArt() {
        return personenKonfliktArt;
      }

  /**
   * 
   *
   * setter for PERSONEN_KONFLIKT.PERSONEN_KONFLIKT_ART
   *
   * @param personenKonfliktArt
   */
  @Override   public void setPersonenKonfliktArt( de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt personenKonfliktArt) {

       resetTkCache();
                  de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt personenKonfliktArtInternal = personenKonfliktArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.personenKonfliktArt
      , personenKonfliktArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPersonenKonfliktArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("personenKonfliktArt");
      }


             if (!isSeitLadenVeraendertPersonenKonfliktArt) {
          isSeitLadenVeraendertPersonenKonfliktArt = thisAttributChanged;
         if (isSeitLadenVeraendertPersonenKonfliktArt){
           wertNachLadenPersonenKonfliktArt=this.personenKonfliktArt;
         }
       }
      

       this.personenKonfliktArt = personenKonfliktArtInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PERSONEN_KONFLIKT_STATUS", nullable = PersonenKonfliktConstants.PERSONEN_KONFLIKT_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus personenKonfliktStatus =  de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus.MANUELL_ZU_PRUEFEN;

  @javax.persistence.Transient
  protected boolean hasChangedPersonenKonfliktStatus = false;

  public boolean hasChangedPersonenKonfliktStatus(){
    return hasChangedPersonenKonfliktStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPersonenKonfliktStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus wertNachLadenPersonenKonfliktStatus;
  
  /**
   * 
   *
   * getter for PERSONEN_KONFLIKT.PERSONEN_KONFLIKT_STATUS
   */
    @Override   public  de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus getPersonenKonfliktStatus() {
        return personenKonfliktStatus;
      }

  /**
   * 
   *
   * setter for PERSONEN_KONFLIKT.PERSONEN_KONFLIKT_STATUS
   *
   * @param personenKonfliktStatus
   */
  @Override   public void setPersonenKonfliktStatus( de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus personenKonfliktStatus) {

       resetTkCache();
                  de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus personenKonfliktStatusInternal = personenKonfliktStatus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.personenKonfliktStatus
      , personenKonfliktStatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPersonenKonfliktStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("personenKonfliktStatus");
      }


             if (!isSeitLadenVeraendertPersonenKonfliktStatus) {
          isSeitLadenVeraendertPersonenKonfliktStatus = thisAttributChanged;
         if (isSeitLadenVeraendertPersonenKonfliktStatus){
           wertNachLadenPersonenKonfliktStatus=this.personenKonfliktStatus;
         }
       }
      

       this.personenKonfliktStatus = personenKonfliktStatusInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Personendaten
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "PERSONENDATEN_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.person.entity.Personendaten personendaten;

  /**
   * 
   */
  @Override
  public void setPersonendaten( de.ivu.elect.business.person.entity.Personendaten personendaten){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.personendaten
    , personendaten);

    attributeChanged |= thisAttributChanged;

    hasChangedPersonendaten |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("personendaten");
    }

    this.personendaten = personendaten;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.person.entity.Personendaten getPersonendaten(){
    return this.personendaten;
  }

  @javax.persistence.Transient
  protected boolean hasChangedPersonendaten = false;

  public boolean hasChangedPersonendaten(){
    return hasChangedPersonendaten;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("PersonenKonflikt:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(PersonenKonflikt other){
                             other.personenKonfliktArt = this.personenKonfliktArt;
                                other.personenKonfliktStatus = this.personenKonfliktStatus;
           
  other.setPersonendaten(this.getPersonendaten());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(PersonenKonflikt.class)){
        copyEntityAttributesUsingSetter((PersonenKonflikt) other.castTo(PersonenKonflikt.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von PersonenKonflikt: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(PersonenKonflikt other){
               other.setPersonenKonfliktArt(this.personenKonfliktArt);
                  other.setPersonenKonfliktStatus(this.personenKonfliktStatus);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(PersonenKonflikt other){
                       if (hasChangedPersonenKonfliktArt) {
        other.setPersonenKonfliktArt(this.personenKonfliktArt);
      }
                             if (hasChangedPersonenKonfliktStatus) {
        other.setPersonenKonfliktStatus(this.personenKonfliktStatus);
      }
             }





    @javax.persistence.Transient
    private transient PersonenKonfliktTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public PersonenKonfliktTK getPersonenKonfliktTK(){
    if (tkCache==null) {
    tkCache = new PersonenKonfliktTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getPersonenKonfliktTK();
    }

  @Override
  public PersonenKonfliktUK getUk(){
    return getPersonenKonfliktUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return PersonenKonflikt.class;
  }

public PersonenKonfliktUK getPersonenKonfliktUK(){

   return  new PersonenKonfliktUK(



  );
}

  @javax.persistence.Transient
  private transient PersonenKonfliktProperties properties;

  public PersonenKonfliktProperties getProperties(){
    if (properties == null) {
      properties = new PersonenKonfliktProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public PersonenKonfliktProperties getPersonenKonfliktProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return PersonenKonfliktConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_ART_EINZAHL);

        personenKonfliktArt =
     (de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_STATUS_EINZAHL);

        personenKonfliktStatus =
     (de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertPersonenKonfliktArt) {
      result.put(PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenPersonenKonfliktArt , personenKonfliktArt));
    }
                            if (isSeitLadenVeraendertPersonenKonfliktStatus) {
      result.put(PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenPersonenKonfliktStatus , personenKonfliktStatus));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertPersonenKonfliktArt = false;
      wertNachLadenPersonenKonfliktArt = null;
                          isSeitLadenVeraendertPersonenKonfliktStatus = false;
      wertNachLadenPersonenKonfliktStatus = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "PERSONEN_KONFLIKT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "PersonenKonflikt";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(personenKonfliktArt, this, PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_ART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(personenKonfliktStatus, this, PersonenKonfliktConstants.MESSAGE_KEY_PERSONEN_KONFLIKT_STATUS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
